/* asm_byte.c - 6502 assembler (horrible unfinished hackofathing)
 *
 * Copyright (C) 2017 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <stdio.h>

#include "xlib/xutil.h"

#include "asm_byte.h"


unsigned int
byte_rotate_left (Byte b)
{
	return (b << 1) | (b >> 7);
}


unsigned int
byte_rotate_right (Byte b)
{
	return (b >> 1) | (b << 7);
}


Byte
byte_add_with_carry (Byte a, Byte b, xbool_t *carry)
{
	unsigned int result;

	result = (unsigned int)a + (unsigned int)b;
	if (carry != NULL) {
		*carry = (result > 0xFF);
	}

	return result;
}


void
byte_set_bit (Byte b, int bit, xbool_t state)
{
	if (state == TRUE) {
		SET_BIT(b, bit);
	}
	else {
		CLEAR_BIT(b, bit);
	}
}


void
word_copy (Word *w_dest, Word *w_source)
{
	w_dest->lsb = w_source->lsb;
	w_dest->msb = w_source->msb;
}


void
word_set (Word *w, int data)
{
	w->msb = (data >> 8) & 0xFF;
	w->lsb = data & 0xFF;
}


int
word_to_integer (Word *w)
{
	/* XXX */
	return (int)(w->msb * BYTE_MAX) + w->lsb;
}

