/* cpu.h
 *
 * Copyright (C) 2017 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */


#ifndef HAVE_CPU_H
#define HAVE_CPU_H

#include "memory.h"
#include "machine.h"


typedef enum {

	CPU_TYPE_6502

} CpuType;


typedef struct _CPU CPU;


CPU*   cpu_new (Machine *m, const char *progname, Memory *bus[], CpuType type,
                int vector_reset, int vector_nmi, int vector_irq);
void   cpu_free (CPU *cpu);
void   cpu_status_dump (FILE *f, CPU *cpu);
xbool_t cpu_run (CPU *cpu, int origin);

void   cpu_signal_reset (CPU *cpu);
void   cpu_signal_toggle_stepping (CPU *cpu);
void   cpu_signal_step_now (CPU *cpu);


#endif

