/* xmem.h
 *
 * Copyright (C) 2005, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

#ifndef XMEM_H
#define XMEM_H


#define xnew(obj_type, n)       xmalloc (sizeof(obj_type) * (n))
#define xnew0(obj_type, n)      xcalloc (1, sizeof(obj_type) * (n))

void*   xmalloc (size_t size);
void*   xcalloc (size_t nmemb, size_t size);
void*   xrealloc (void *p, size_t size);
void    xfree (void *p);


#endif /* XMEM_H */

